using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
//Chill Dude
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Felicity - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A weird dude.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("feli thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("feli skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Orange Guy - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Vitamins!", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("orange tumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("nara bone layer.png");

            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("Helmet");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(0.04f, 0.16f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("hat n.png");
            childSprite.sortingLayerName = "Top";





            var person = Instance.GetComponent<PersonBehaviour>();


            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Sr Chill - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "he is nice.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("sr chill thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("sr chill skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);




//dragon
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "The DRAGON. - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "be careful.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("zero thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("zero skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("Helmet");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(-0.2f, 0.15f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("hair.png");
            childSprite.sortingLayerName = "Top";


            var person = Instance.GetComponent<PersonBehaviour>();

            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


//skeleton
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Skeleton - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "very fragile, be careful with him.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("skele thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Bone layer.png");
            var flesh = ModAPI.LoadTexture("broken bone layer.png");
            var bone = ModAPI.LoadTexture("Sbroken bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();


            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


//meat
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Flesh Man - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "very fragile, be careful with him.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("flesh thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("flesh layer.png");
            var flesh = ModAPI.LoadTexture("bone layer.png");
            var bone = ModAPI.LoadTexture("broken bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();


            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


//reverse
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Reverse Man - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "wth?", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("reverse thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("bone layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("origi skin layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();


            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


//marcelo agachate y conocelo
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Marcelo drip - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Haha is just a dude with a marcelo shirt and drip pants", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("duck thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("duck skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("Helmet");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(0.060f, 0f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("duck hat.png");
            childSprite.sortingLayerName = "Top";





            var person = Instance.GetComponent<PersonBehaviour>();


            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);


//clown.
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Clown Dude - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "He have depression.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("clown thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("clown skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

            var head = Instance.transform.GetChild(5);
            var childObject = new GameObject("Helmet");
            childObject.transform.SetParent(head);
            childObject.transform.localPosition = new Vector3(0.01f, 0.13f);
            childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("clown hair.png");
            childSprite.sortingLayerName = "Top";





            var person = Instance.GetComponent<PersonBehaviour>();


            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);



ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
        NameOverride = "Cyborg - More Humans Mod", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "ayO???", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("cyborg thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("cybor skin layer.png");
            var flesh = ModAPI.LoadTexture("wire layer.png");
            var bone = ModAPI.LoadTexture("endo bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
            person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
            person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(0, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
        }
    }
}